-- Define variables to keep track of swipe gesture and selected option
local startY = 0
local deltaY = 0
isSwiping = false
 menuVisible = false
selectedOption = nil
threshold = 50 -- Threshold to switch between options
local options = {"Option 1", "Option 2", "Option 3", "Option 4"}

-- Variables for scrolling
local scrollOffsetY = 0
local lastMouseY = 0
local mouseHeld = false
local hasSwiped = false -- Flag to indicate if a swipe has occurred

function love.mousepressed(x, y, button, istouch, presses)
    mouseHeld = true
    startY = y
    isSwiping = true
    scrollOffsetY = y
    hasSwiped = false -- Reset swipe flag on mouse press
end

function love.mousereleased(x, y, button, istouch, presses)
    mouseHeld = false
    isSwiping = false
    menuVisible = false
    
    lastMouseY = 0
    if not hasSwiped then
        selectedOption = nil
    end
    deltaY = 0
    
    -- Perform action based on selected option
    if selectedOption == options[1] then 
		   
           ce = code_editor.new(12, 12, 1000, 1680)
		font = lg.newFont("RobotoMono-Medium.ttf", 24)
        ce:set_font(font)
            GUI_Sound_Effects_072:play()
        
    elseif selectedOption == options[2] then 
       
		
		ce = code_editor.new(12, 12, 1000, 1680)
		font = lg.newFont("RobotoMono-Medium.ttf", 24)
        ce:set_font(font)
		ce:load("save.lua") -- Load the content from the "savelua" file into the editor
        print("Load savelua")
        
        GUI_Sound_Effects_071:play()
        
    elseif selectedOption == options[3] then 
        -- Add action for the third option here
        print("Save document")
        saveToFile("save.lua", TextContent)
       
        

    elseif selectedOption == options[4] then 
        -- Add your action for Option 4 here
         print("Exit")
        love.event.quit()
        print("Option 4 selected")    
    elseif selectedOption == nil then 
        print("No options selected")
    end
    
end



function love.mousemoved(x, y, dx, dy, istouch)
    if mouseHeld then
        deltaY = y - startY
        
        -- Adjust the scroll offset based on mouse movement
        if scrollOffsetY < 200 then 
            scrollOffsetY = scrollOffsetY + dy * 1
            
        end

        -- Adjust the threshold values to accommodate three options
         if deltaY > threshold * 4 then
            hasSwiped = true
            selectedOption = options[4]  -- Select the third option
            menuVisible = true
            GUI_Sound_Effects_027:play()
        elseif deltaY > threshold * 3 then
            hasSwiped = true
            selectedOption = options[3]  -- Select the third option
            menuVisible = true
            GUI_Sound_Effects_027:play()
        elseif deltaY > threshold * 2 then
            hasSwiped = true
            selectedOption = options[2]  -- Select the second option
            menuVisible = true
        elseif deltaY > threshold then
            hasSwiped = true
            selectedOption = options[1]  -- Select the first option
            menuVisible = true
        else
            selectedOption = nil
            menuVisible = false
            scrollOffsetY = 0
        end
    end
end



function revealMenu()
    local width, height = love.graphics.getDimensions()
    
    local optionHeight = 50
    local optionSpacing = 50
    local menuWidth = width
    local baseY = (optionHeight - optionSpacing / 2) + scrollOffsetY - 50
     local transparency = 0.7
    love.graphics.setColor(0, 0, 1, transparency) -- Option 1 color (blue)
    love.graphics.rectangle("fill", 0, baseY, menuWidth, optionHeight)
    
    love.graphics.setColor(1, 0, 0, transparency) -- Option 2 color (red)
    love.graphics.rectangle("fill", 0, baseY - optionSpacing, menuWidth, optionHeight)
    
    love.graphics.setColor(0, 1, 0, transparency) -- Option 3 color (green)
    love.graphics.rectangle("fill", 0, baseY - 2 * optionSpacing, menuWidth, optionHeight)
    
    love.graphics.setColor(0, 1, 1, transparency) -- Option 4 color (yellow)
    love.graphics.rectangle("fill", 0, baseY - 3 * optionSpacing, menuWidth, optionHeight)
    
    love.graphics.setFont(Mono64_0xA000)
    
    for i, option in ipairs(options) do
        local optionY = baseY - (i - 1) * optionSpacing
        
        if selectedOption == option then
            --love.graphics.setColor(0, 1, 0, 1) -- Highlight color (green, semi-transparent)
            local transparency = 1
            love.graphics.rectangle("fill", 0, optionY, menuWidth, optionHeight)
            love.graphics.setColor(1, 1, 1, 1) -- Text color (white)
            
            -- Adjust text based on the option
            local text = ""
            if option == "Option 1" then
                text = "New document"
            elseif option == "Option 2" then
                text = "Load"
            elseif option == "Option 3" then
                text = "Save document"
            elseif option == "Option 4" then
                text = "Exit"
            end
            
            love.graphics.printf(text, width / 22, optionY, 1000, "center", 0, 1)
        end
    end
    
    love.graphics.setFont(Regular12_0xA000)
end


function hideMenu()
    menuVisible = false
    isSwiping = false
end
